<?
/*****************************************************************************/
/* Packages.php                                                              */
/*****************************************************************************/
/* YaBB: Yet another Bulletin Board                                          */
/* Open-Source Project started by Zef Hemel (zef@zefnet.com)                 */
/* Software Version: YaBB SE                                                 */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabb.info                          */
/* Support, News, Updates at:  http://www.yabb.info/community                */
/*                             http://yabb.xnull.com/community               */
/* ========================================================================= */
/* Copyright (c) 2001-2002 Lewis Media - All Rights Reserved                 */
/* Software by: The YaBB Development Team                                    */
/*****************************************************************************/
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General */
/* Public License for more details.                                          */
/*                                                                           */
/* The GNU GPL can be found in gpl.txt in this directory                     */
/*****************************************************************************/

global $adminplver;
$adminplver="YaBB SE";

include_once("Sources/Packer.php");
// verify the user is an administrator
is_admin();

function Packages()
{
   global $txt, $color, $scripturl, $yytitle;

	$yytitle = $txt['yse131'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse131]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
        <b>$txt[yse132]</b><br>
        <i>$txt[yse133]</i>
EOT;

   if($dir = @opendir("Packages"))
   {
      echo "<ul>";
      while($file = readdir($dir))
      {
         if(!strstr($file, ".yp"))
            continue;
         echo "<li>$file\n";
         if(ereg("(.+)\.mod\.yp", $file, $regs))
   	      echo "<a href=\"$scripturl?action=packagepremod;file=$file\">[ $txt[yse134] ]</a>\n";
         if(ereg("(.+)\.as\.yp", $file, $regs))
   	      echo "<a href=\"$scripturl?action=packageavatars;file=$file\">[ $txt[yse135] ]</a>\n";
         if(ereg("(.+)\.lp\.yp", $file, $regs))
   	      echo "<a href=\"$scripturl?action=packagelanguage;file=$file\">[ $txt[yse136] ]</a>\n";
 
         echo "<a href=\"$scripturl?action=packagelist;file=$file\">[ $txt[yse137] ]</a>
               <a href=\"$scripturl?action=packageremove;file=$file\">[ $txt[yse138] ]</a>";
       }
       closedir($dir);
       echo <<<EOT
       </ul>
       <a href="$scripturl?action=packagecreate">[ $txt[yse139] ]</a><br>
       <a href="$scripturl?action=packageget">[ $txt[yse140] ]</a><br>
   </td>
   </tr>
   </table></td></tr></table>
EOT;
   }
 	footer();
	obExit();
}

function PackageRemove()
{
   global $scripturl, $file;

   unlink("Packages/".$file);

   header("Location: $scripturl?action=packages\n\n");
}

function PackageCreate()
{
   global $txt, $color, $scripturl, $yytitle;

   $yytitle = $txt['yse141'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]"$txt[yse141]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
    <form action="$scripturl?action=packagecreate2" method="POST">
    <table border=0 cellspacing=0 cellpadding=4>
    <tr>
       <th colspan=2>$txt[yse142]</td>
    </tr>
    <tr>
       <td valign=top><b>$txt[yse143]:</b></td>
       <td valign=top><input type=text name="dir" size=30><br>
       <font size=1>$txt[yse144]</font></td>
    </tr>
    <tr>
       <td valign=top><b>$txt[yse145]:</b></td>
       <td valign=top><input type=text name="root" size=30><br>
       <font size=1>$txt[yse146]</font></td>
    </tr>
    <tr>
       <td valign=top><b>$txt[yse147]:</b></td>
       <td valign=top><input type=text name="name" size=30 value=".yp"></td>
    </tr>
    <tr>
       <td colspan=2><input type=submit value="$txt[yse148]"></td>
    </tr>
    </table></td></tr></table>
    </td>
   </tr>
   </table></td></tr></table>
EOT;
  	footer();
	obExit();

}

function PackageCreate2()
{
   global $txt, $color, $scripturl, $yytitle, $name, $dir, $root;

   $yytitle = $txt['yse141'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse141]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
EOT;
  $packer = new Packer("Packages/$name");

  echo <<<EOT
   <table border=0 cellspacing=0 cellpadding=4>
   <tr>
      <th colspan=2>$txt[yse149]</th>
   </tr>
   <tr>
      <td class=td1>
EOT;
  $packer->addFiles(array("./".$dir), "./".$root);


  echo "$txt[51]<br>$txt[yse150]: <a href=\"Packages/$name\">[ $txt[yse151] ]</a><br><br>
    <a href=\"$scripturl?action=packagecreate\">[ $txt[193] ]</a>
   </td>
   </tr>
   </table></td></tr></table>
   </td>
   </tr>
   </table></td></tr></table>   ";
  	footer();
	obExit();
}


function PackagePremod()
{
   global $txt, $color, $scripturl, $file, $yytitle;

	$yytitle = $txt['yse153'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse153]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
      $txt[yse152]
      <a href="$scripturl?action=packagemod;file=$file">[ $txt[yse154] ]</a>
      </td>
   </tr>
   </table></td></tr></table>
EOT;
  	footer();
	obExit();
}

function PackageMod()
{
   global $txt, $color, $scripturl, $file, $yytitle;

	$yytitle = $txt['yse155'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse156]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
EOT;
  
  $packer = new Packer("Packages/$file");
  echo $packer->extract(".");

  if(file_exists("Packages/modification.mod"))
    echo "
      $txt[yse157]<br>
      <a href=\"$scripturl?action=packagemod2;try=1\">[ $txt[yse158] ]</a>
      <a href=\"$scripturl?action=packagemod2;try=0\">[ $txt[yse159] ]</a><br>";
  elseif(file_exists("Packages/modification.php"))
    echo "
      $txt[yse160]<br>
      <a href=\"$scripturl?action=packagemod3\">[ $txt[yse161] ]</a><br>";
  elseif(file_exists("Packages/modification.txt"))
    echo "
      $txt[yse162]<br>
      <a href=\"$scripturl?action=packagemod4\">[ $txt[yse163] ]</a><br>";
  else
    echo "
      $txt[yse164]<br><br>
      <a href=\"$scripturl?action=packages\">[ $txt[193] ]</a><br>";
   
  echo "</td></tr></table></td></tr></table>";
  	footer();
	obExit();
}

function PackageMod2()
{
   global $txt, $color, $scripturl, $yytitle, $try;
	$yytitle = $txt['yse155'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse155]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
EOT;

  // Apply mod
  $file = implode("", file("Packages/modification.mod"));
  $file = str_replace("\r", "", $file);

  // Now find and parse the mod info
  $currentfile = "";
  $filecontents = "";
  $searchfor = "";

  while(preg_match("/<(file|search|add|replace)>\n(.+?)\n<\\/\\1>/is", $file, $regs))
  {
    if($regs[1] == "file")
    {
      if($currentfile && !$try)
      {
         copy($currentfile, $currentfile."~");
         $fp = fopen($currentfile, "w");
         fputs($fp, $filecontents);
         fclose($fp);
         echo "<b>$txt[yse165] $currentfile, $txt[yse166] ".$currentfile."~</b><br>\n";
      }
      $currentfile = $regs[2];
      $filecontents = implode("", file($currentfile));
      $filecontents = str_replace("\r", "", $filecontents);
      echo "<h2>$currentfile</h2>";
    }
    elseif($regs[1] == "search")
    {
      $searchfor = $regs[2];
      echo "$txt[yse167] <hr><pre>$searchfor</pre><hr>";
    }
    elseif($regs[1] == "add")
    {
      if(strstr($filecontents, $searchfor))
      {
         echo "$txt[yse168]<hr><pre>$regs[2]</pre><hr>";
         $filecontents = str_replace($searchfor, $searchfor."\n".$regs[2], $filecontents);
      }
      else
         echo "$txt[yse169]<br>";
      $searchfor = "";
    }
    elseif($regs[1] == "replace")
    {
      if(strstr($filecontents, $searchfor))
      {
         echo "$txt[yse170]<hr><pre>$regs[2]</pre><hr>";
         $filecontents = str_replace($searchfor, $regs[2], $filecontents);
      }
      else
         echo "$txt[yse169]<br>";
      $searchfor = "";
    }
    $file = str_replace("<$regs[1]>\n$regs[2]\n</$regs[1]>", "", $file);
  }
  if($currentfile && !$try)
  {
    copy($currentfile, $currentfile."~");
    $fp = fopen($currentfile, "w");
    fputs($fp, $filecontents);
    fclose($fp);
    echo "<b>$txt[yse165] $currentfile, $txt[yse165] ".$currentfile."~</b><br>\n";
  }
  echo "$txt[51]<br><br>";

  // Done...
  //unlink("../packages/modification.mod");
  if($try)
     echo $txt['yse171'];
  else
  {
     echo $txt['yse172'];

     if(file_exists("Packages/modification.php"))
       echo "
         $txt[yse160]<br>
         <a href=\"$scripturl?action=packagemod3\">[ $txt[yse161] ]</a><br>";
     elseif(file_exists("Packages/modification.txt"))
       echo "
         $txt[yse162]<br>
         <a href=\"$scripturl?action=packagemod4\">[ $txt[yse163] ]</a><br>";
     else
       echo "
         $txt[yse164]<br><br>
         <a href=\"$scripturl?action=packages\">[ $txt[193] ]</a><br>";
  }
  echo "</td></tr></table></td></tr></table>";
  footer();
  obExit();
}

function PackageMod3()
{
   global $txt, $color, $scripturl, $yytitle, $try;
	$yytitle = $txt['yse155'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse155]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
EOT;
  echo "<b>$txt[yse173]</b><hr>";

  include("Packages/modification.php");
  
  //unlink("../packages/modification.php");
  if(file_exists("Packages/modification.txt"))
    echo "
      $txt[yse162]<br>
      <a href=\"$scripturl?action=packagemod4\">[ $txt[yse163] ]</a><br>";
  else
    echo "
      $txt[yse164]<br><br>
      <a href=\"$scripturl?action=packages\">[ $txt[193] ]</a><br>";
  echo "</td></tr></table></td></tr></table>";
  footer();
  obExit();
}

function PackageMod4()
{
   global $txt, $color, $scripturl, $yytitle, $try;
	$yytitle = $txt['yse155'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse174]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
EOT;
  echo "<b>$txt[yse175]</b><br>";
  echo "<hr><pre>";
  echo htmlspecialchars(implode("", file("Packages/modification.txt")));
  echo "</pre><hr>";

  //unlink("../packages/modification.txt");
  echo "
    $txt[yse164]<br><br>
      <a href=\"$scripturl?action=packages\">[ $txt[193] ]</a><br>";
  echo "</td></tr></table></td></tr></table>";
  footer();
  obExit();
}

function PackageAvatars()
{
   global $txt, $color, $scripturl, $file, $yytitle;

	$yytitle = $txt['yse176'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse176]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
EOT;
  
  $packer = new Packer("Packages/$file");
  echo $packer->extract(".");

  echo <<<EOT
$txt[yse177]<br><br>
<a href="$scripturl?action=packages">[ $txt[193] ]</a><br>
</td></tr></table></td></tr></table>
EOT;
  	footer();
	obExit();
}

function PackageLanguage()
{
   global $txt, $color, $scripturl, $file, $yytitle;

	$yytitle = $txt['yse178'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse178]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
EOT;
  
  $packer = new Packer("Packages/$file");
  echo $packer->extract(".");

  echo <<<EOT
$txt[yse179]<br><br>
<a href="$scripturl?action=packages">[ $txt[193] ]</a><br>
</td></tr></table></td></tr></table>
EOT;
  	footer();
	obExit();
}


function PackageList()
{
   global $txt, $color, $scripturl, $file;

	$yytitle = $txt['yse180'];
	template_header();
	print <<<EOT
<table border="0" cellpadding="0" cellspacing="6" align="center" width="100%">
  <tr>
    <td colspan=2 width="100%">
    <table border="0" cellpadding="5" cellspacing="1" align="center" bgcolor="$color[bordercolor]" class="bordercolor" width="100%">
      <tr>
        <td bgcolor="$color[titlebg]" class="titlebg" height="23" align="center" colspan="2">
        <font size="4" color="$color[titletext]">$txt[yse180]</font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color[windowbg]" valign="middle" align="left" width="100%">
EOT;
  $packer = new Packer("Packages/$file");
  $files = $packer->listFiles();
  echo "
  <b>$txt[yse181] $file</b>
  <ol>";
  for($i=0 ; $i<count($files); ++$i)
  {
    echo "<li>".$files[$i]['name']." (".$files[$i]['size']." bytes)\n";
  }
  echo "</ol><a href=\"$scripturl?action=packages\">[ $txt[193] ]</a>";
  echo "</td></tr></table></td></tr></table>";
  	footer();
	obExit();
}

?>